﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = CreateTable(3, 10).DefaultView;            
        }

        public DataTable CreateTable(int columns, int rows)
        {
            DataTable d = new DataTable();
            Random r = new Random();

            for (int i = 0; i < columns; i++)
            {
                d.Columns.Add(new DataColumn("Column" + i, typeof(int)));
            }
            for (int i = 0; i < rows; i++)
            {
                DataRow row = d.NewRow();

                for (int j = 0; j < columns; j++)
                {
                    row["Column" + j] = r.Next(1000 * i);
                }

                d.Rows.Add(row);
            }
            return d;
        }

        private void LabelPresenter_Loaded(object sender, RoutedEventArgs e)
        {
            Binding b = new Binding();
            b.Source = sender;
            b.Path = new PropertyPath("ActualWidth");
            b.Converter = new GridLengthConverter();
            grid1.ColumnDefinitions[0].SetBinding(ColumnDefinition.WidthProperty, b);
        }
    }


    public class GridLengthConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            double val = (double)value;
            GridLength gridLength = new GridLength(val);
            return gridLength;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return Binding.DoNothing;
        }
    }
}
